﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Employees employees = new Employees();
        public Employees Employees
        {
            get { return employees; }
            set { employees = value; }
        }
        public MainWindow()
        {
            InitializeComponent();
            Employees employees = new Employees();
            dynamic employee = new Employee();
            employee.FirstName = "Michael";
            employee.LastName = "Jordan";
            employee.SecondName = "Jordan2";
            Employees.Add(employee);
            dynamic employee2 = new Employee();
            employee2.FirstName = "Max";
            employee2.LastName = "Headroom";
            employee2.SecondName = "Jordan3";
            Employees.Add(employee2);

             
            this.DataContext = Employees;

            xdg.FieldLayouts[0].Fields.Add(new UnboundField()
            {
                Label = "FirstName",
                Binding = new Binding("FirstName")
            });

            xdg.FieldLayouts[0].Fields.Add(new UnboundField()
            {
                Label = "SecondName",
                Binding = new Binding("SecondName")
            });

            xdg.FieldLayouts[0].Fields.Add(new UnboundField()
            {
                Label = "LastName",
                Binding = new Binding("LastName")
            });

        }
    }


    public class Employees : ObservableCollection<dynamic>
    {
        #region ITypedList


        public string GetListName(PropertyDescriptor[] listAccessors)
        {
            return null;
        }

        #endregion ITypedList
    }

    public class Employee : DynamicObject, INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(string property)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(property));
            }
        }

        public override IEnumerable<string> GetDynamicMemberNames()
        {
            return (from dicEntry in properties select dicEntry.Key).ToArray();

        }

        #region DynamicObject

        public Dictionary<string, object> properties = new Dictionary<string, object>();

        public override bool TryGetMember(GetMemberBinder binder, out object result)
        {
            if (properties.ContainsKey(binder.Name))
            {
                result = properties[binder.Name];
                return true;
            }
            else
            {
                result = "Invalid Property!";
                return false;
            }
        }
        
        public override bool TrySetMember(SetMemberBinder binder, object value)
        {
            properties[binder.Name] = value;
            NotifyPropertyChanged(binder.Name);
            return true;
        }

        public override bool TryInvokeMember(InvokeMemberBinder binder, object[] args, out object result)
        {
            dynamic method = properties[binder.Name];
            result = method(args[0].ToString(), args[1].ToString());
            return true;
        }

        #endregion DynamicObject

        public bool RemoveProperty(string property)
        {
            return properties.Remove(property);
        }

       
    }

    public class DynamicPropertyDescriptor : PropertyDescriptor
    {
        public DynamicPropertyDescriptor(string name)
            : base(name, null)
        {
        }

        public override bool CanResetValue(object component)
        {
            return false;
        }

        public override object GetValue(object component)
        {
            return this.Name;
        }

        public override void ResetValue(object component)
        {

        }

        public override void SetValue(object component, object value)
        {
            throw new Exception();
        }

        public override bool ShouldSerializeValue(object component)
        {
            return false;
        }

        public override Type ComponentType
        {
            get { return typeof(object); }
        }

        public override bool IsReadOnly
        {
            get { return false; }
        }

        public override Type PropertyType
        {
            get
            {
                return typeof(object);
            }
        }
    }

}
